//Adventure-06 style spring behavior, by Azuma The Fox.

//Custom 'Springing' flag.
addHook("ThinkFrame", do
	for player in players.iterate
		//Eliminate possibilitys of NOT using A spring.
		//Obviously, since this is a workaround, it's far from perfect.
		if not P_IsObjectOnGround(player.mo)
		and not P_InQuicksand(player.mo)
		and not P_PlayerInPain(player)
		and not P_CheckDeathPitCollide(player.mo)
		and not (player.pflags & PF_SLIDING)	
		and not (player.pflags & PF_SPINNING)
		and not (player.pflags & PF_JUMPED)
		and not (player.powers[pw_carry])
		and not (player.skidtime > 0)
		and not (player.exiting)
		and not (player.gotflag)
		and not (player.pflags & PF_THOKKED)
		then
		//check for inversion, and assume player used a spring.
			if (player.mo.eflags & MFE_VERTICALFLIP)
				if player.mo.momz < -14*FRACUNIT
					player.springing = 1
				end
			else
				if player.mo.momz > 14*FRACUNIT
					player.springing = 1
				end
			end
		end
		//dissable on land, or other.
		if P_IsObjectOnGround(player.mo)
		or P_PlayerInPain(player)
		or P_CheckDeathPitCollide(player.mo)
		or (player.powers[pw_carry])
			player.springing = 0
		end		
	end
end)

//Change animations Code. *Not guaranteed to work with all character mods*
addHook("ThinkFrame", do
	for player in players.iterate
		if not P_IsObjectOnGround(player.mo)
		and not (player.pflags & PF_SPINNING)
		and not (player.pflags & PF_STARTDASH)
        and not (player.pflags & PF_THOKKED) 
		and not (player.powers[pw_carry])
		and not P_PlayerInPain(player)
		and not (player.playerstate == PST_DEAD)
		and not (player.mo.state == S_PLAY_SUPER_TRANS1)//Patch so Super Forms work.
		and not (player.mo.state == S_PLAY_SUPER_TRANS2)
		and not (player.mo.state == S_PLAY_SUPER_TRANS3)
		and not (player.mo.state == S_PLAY_SUPER_TRANS4)
		and not (player.mo.state == S_PLAY_SUPER_TRANS5)
		and not (player.mo.state == S_PLAY_SUPER_TRANS6)
		and not (player.mo.state == S_PLAY_FLOAT)
		and not (player.mo.state == S_PLAY_FLOAT_RUN)
		and not (player.mo.state == S_PLAY_CLIMB)//Patch to not bork up climing animation.
		and not (player.mo.state == S_PLAY_CLING)
		then
		//if Player has jumped
			if(player.pflags & PF_JUMPED)
			and not (player.pflags & PF_SPINNING)
			and (player.springing == 0)
				if (player.sflags == SF_NOJUMPSPIN)//For those who don't Spinjump.(.sflags was genuinely a guess)
					if (player.mo.eflags & MFE_VERTICALFLIP)
						if player.mo.momz < -1*FRACUNIT
							player.mo.state = S_PLAY_SPRING
						elseif player.mo.momz > 1*FRACUNIT
							player.mo.state = S_PLAY_FALL
						end
					else
						if player.mo.momz > 1*FRACUNIT
							player.mo.state = S_PLAY_SPRING
						elseif player.mo.momz < -1*FRACUNIT
							player.mo.state = S_PLAY_FALL
						end
					end
				else
					//P_SpawnThokMobj(player) //For Adventure jump aura, Dissabled to reduce visual noise.(if I knew how to make a toggle command, I would.)
					if (player.mo.eflags & MFE_VERTICALFLIP)
						if player.mo.momz < 5*FRACUNIT
							player.mo.state = S_PLAY_JUMP
						elseif player.mo.momz > 5*FRACUNIT
							player.mo.state = S_PLAY_FALL
						end
					else
						if player.mo.momz > -5*FRACUNIT
							player.mo.state = S_PLAY_JUMP
						elseif player.mo.momz < -5*FRACUNIT
							player.mo.state = S_PLAY_FALL
						end
					end
				end
		//Spring
			elseif not (player.pflags & PF_JUMPED)
			and (player.springing == 1)
				if (player.mo.eflags & MFE_VERTICALFLIP)
					if player.mo.momz < -5*FRACUNIT
						player.mo.state = S_PLAY_SPRING
					elseif player.mo.momz > -5*FRACUNIT and player.mo.momz < 5*FRACUNIT
						player.mo.state = S_PLAY_JUMP
						player.pflags = $ |(PF_JUMPED) //Enable jump action.
					elseif player.mo.momz > 5*FRACUNIT
						player.mo.state = S_PLAY_FALL
					end
				else
					if player.mo.momz > 5*FRACUNIT
						player.mo.state = S_PLAY_SPRING
					elseif player.mo.momz < 5*FRACUNIT and player.mo.momz > -5*FRACUNIT
						player.mo.state = S_PLAY_JUMP
						player.pflags = $ |(PF_JUMPED) //Enable jump action.
					elseif player.mo.momz < -5*FRACUNIT
						player.mo.state = S_PLAY_FALL
					end
				end
		//Spring Action
			elseif (player.pflags & PF_JUMPED)
			and (player.springing == 1)
				if (player.mo.eflags & MFE_VERTICALFLIP)
					if player.mo.momz < -5*FRACUNIT
					player.mo.state = S_PLAY_SPRING
				elseif player.mo.momz > -5*FRACUNIT and player.mo.momz < 5*FRACUNIT
						player.mo.state = S_PLAY_JUMP
					elseif player.mo.momz > 5*FRACUNIT
						player.mo.state = S_PLAY_FALL
					end
				else
					if player.mo.momz > 5*FRACUNIT
						player.mo.state = S_PLAY_SPRING
					elseif player.mo.momz < 5*FRACUNIT and player.mo.momz > -5*FRACUNIT
						player.mo.state = S_PLAY_JUMP
					elseif player.mo.momz < -5*FRACUNIT
						player.mo.state = S_PLAY_FALL
					end
				end
		//Else/Other
			elseif not (player.pflags & PF_JUMPED)
			and not (player.pflags & PF_SPINNING)
			and (player.springing == 0)
				if (player.mo.eflags & MFE_VERTICALFLIP)
					if player.mo.momz < -1*FRACUNIT
						player.mo.state = S_PLAY_SPRING
					elseif player.mo.momz > 1*FRACUNIT
						player.mo.state = S_PLAY_FALL
					end
				else
					if player.mo.momz > 1*FRACUNIT
						player.mo.state = S_PLAY_SPRING
					elseif player.mo.momz < -1*FRACUNIT
						player.mo.state = S_PLAY_FALL
					end
				end
			
//Scrapped code. If you can make it work, good on you.
	/*	//Roll off ledge not water
			elseif not (player.pflags & PF_JUMPED)
			and (player.pflags & PF_SPINNING)
			and (player.springing == 0)
				if not (player.mo.eflags & MFE_GOOWATER)
				and not (player.mo.eflags & MFE_TOUCHWATER)
				and not (player.mo.eflags & MFE_UNDERWATER)
					player.pflags = $ |(PF_JUMPED)
				elseif (player.mo.eflags & MFE_GOOWATER)
				or (player.mo.eflags & MFE_TOUCHWATER)
				or (player.mo.eflags & MFE_UNDERWATER)
					player.pflags = $1 & ~PF_JUMPED
				end*/
		//Roll off ledge
//			elseif not (player.pflags & PF_JUMPED)
//			and (player.pflags & PF_SPINNING)
//			and (player.springing == 0)
//				player.pflags = $ |(PF_JUMPED)
			
			end
		end
	//Recurl when Thok.
		if player.mo and player.mo.skin == "sonic"
		and not P_IsObjectOnGround(player.mo)
		and not (player.mo.state == S_PLAY_FLOAT)
		and not (player.mo.state == S_PLAY_FLOAT_RUN)
		and (player.pflags & PF_THOKKED) 
			player.mo.state = S_PLAY_JUMP
			P_SpawnThokMobj(player)
		end
	end
end)
